;test ptpcam_dll
#AutoIt3Wrapper_UseX64=n  ; !! is only a 32-Bit DLL !!


#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
Opt("GUIOnEventMode", 1)

Enum $GUI_RUN, $GUI_END
Enum $PTP_RUN, $PTP_END

Global $PTPstate = $PTP_END, $GuiRunState = $GUI_RUN
Global $Hdll = 0

#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("dll TEST", 615, 438, 192, 124)
GUISetOnEvent($GUI_EVENT_CLOSE, "onGuiClose")
$Button1 = GUICtrlCreateButton("open DLL", 40, 40, 75, 25)
GUICtrlSetOnEvent(-1, "onOpen")
$Button2 = GUICtrlCreateButton("close DLL", 144, 40, 75, 25)
GUICtrlSetOnEvent(-1, "onClose")
$Button3 = GUICtrlCreateButton("send", 256, 40, 75, 25)
GUICtrlSetOnEvent(-1, "onSend")
$Button4 = GUICtrlCreateButton("'reset'", 360, 40, 75, 25)
GUICtrlSetOnEvent(-1, "onReset")
$INP = GUICtrlCreateInput("version", 40, 96, 529, 21)
$OUT = GUICtrlCreateEdit("", 40, 144, 529, 257)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###


GUICtrlSetState($Button3, $GUI_DISABLE)
GUICtrlSetState($Button4, $GUI_DISABLE)
While ($GuiRunState = $GUI_RUN)
	Sleep(100)
WEnd

Func StateStr($val)
	If $val=1 Then Return "OK"
	Return "ERR"
EndFunc

Func IsConsoleReady()
	If ($Hdll > 0)And($PTPstate = $PTP_RUN) Then
		Local $res = DLLCall($Hdll, "int", "IsConsoleReady")
		Return $res[0]
	EndIf
EndFunc

Func IsCamConnected()
	If ($Hdll > 0)And($PTPstate = $PTP_RUN) Then
		Local $res = DLLCall($Hdll, "int", "IsCamConnected")
		Return $res[0]
	EndIf
EndFunc

Func WaitForConsoleReady()
	Local $i = 100
	Local $res = 0
	Local $state = IsConsoleReady();
	DebugWrite("wait for ptpcam console: ")
	While (IsConsoleReady() <> -1)And($i>0)And($res=0)
		Sleep(100)
		$i=$i-1
		DebugWrite(".")
		If IsConsoleReady()=1 Then $res=1
	WEnd
	DebugWrite(@CRLF)
	Return $res
EndFunc

Func SendPTP($command)
	If ($Hdll > 0)And($PTPstate = $PTP_RUN) Then
		$res = WaitForConsoleReady()
		DebugWriteLine(" [ console is ready: "&StateStr($res)&" ]")
		DebugWriteLine(" [ cam connected: "&StateStr(IsCamConnected())&" ]")
		If $res=1 Then
			Local $StdIn = $command
			DebugWriteLine(@CRLF&">> StdIN: '"&$StdIn&"'"&@CRLF)
			$res=DLLCall($Hdll, "int", "SendCommand", "str", $StdIn)
			DebugWriteLine("[ send to ptpcam: "&StateStr($res[0])&" ]")

		$res = WaitForConsoleReady()
		DebugWriteLine(" [ console is ready: "&StateStr($res)&" ]")
		If $res=1 Then
				If @error=0 Then
					$res=DLLCall($Hdll, "str", "GetStdOut")
					DebugWriteLine(@CRLF&">> StdOut: '"&$res[0]&"'")
					$res=DLLCall($Hdll, "str", "GetStdErr")
					DebugWriteLine(">> StdErr: '"&$res[0]&"'"&@CRLF)
					DebugWriteLine(" [ cam connected: "&StateStr(IsCamConnected())&" ]")
				EndIf
			EndIf
		EndIf
	EndIf
	DebugWriteLine("----------------------------------------------------------")
EndFunc

Func onClose()
	If $Hdll <> 0 Then
		If $PTPstate = $PTP_RUN Then
			$res=DLLCall($Hdll, "int", "Destroy")
			$PTPstate = $PTP_END
			DebugWriteLine("destroy ptpcam: "&StateStr($res[0]))
		EndIf
		DllClose($Hdll)
		$Hdll = 0
		DebugWriteLine("close DLL (handle: "& $Hdll&")")
	Else
		DebugWriteLine("DLL is closed")
	EndIf
	If ($Hdll <> 0)Or($PTPstate <> $PTP_END) Then DebugWriteLine("onClose ptpcam faild!")
	GUICtrlSetState($Button3, $GUI_DISABLE)
	GUICtrlSetState($Button4, $GUI_DISABLE)
	DebugWriteLine(@CRLF)
EndFunc

Func onOpen()
	If $Hdll = 0 Then
		$Hdll = DllOpen("ptpcam.dll")
		DebugWriteLine("open DLL (handle: "& $Hdll&")")
	EndIf
	If ($Hdll > 0)And($PTPstate = $PTP_END) Then
		$res=DLLCall($Hdll, "int", "Create","int",0)  ;1=show ptpcam-window for debug
		If $res[0] = 1 Then $PTPstate = $PTP_RUN
		DebugWriteLine("create ptpcam: "&StateStr($res[0]))
		GUICtrlSetState($Button3, $GUI_ENABLE)
		GUICtrlSetState($Button4, $GUI_ENABLE)
	EndIf
	If ($Hdll = 0)Or($PTPstate <> $PTP_RUN) Then DebugWriteLine("onOpen ptpcam faild!")
	DebugWriteLine("----------------------------------------------------------")
EndFunc

Func onSend()
	SendPTP(GuiCtrlRead($INP))
EndFunc

Func onReset()
	SendPTP("reset")
EndFunc

Func onGuiClose()
	onClose()
	$GuiRunState = $GUI_END
EndFunc

Func DebugWrite($output)
	GUICtrlSetData($OUT, $output,1)
EndFunc

Func DebugWriteLine($output)
	DebugWrite($output&@CRLF)
EndFunc